<?


/** 
 ** tag: branch
 ** desc: crea menu seconda la logica dell'albero del sito, alias ramo
 ** opt: target la pagina a cui far riferimento per i comdandi, se non fornito default pagina corrente
 ** opt: relationship alias parentela, puo essere sons|figli, fratelli|brothers, genitore|parent. default figli
 ** opt: show puo` essere news o node. se non fornito vengono visualizzati entrambi.
 ** opt: ord campo di ordinamento (puo' essere rilevanza, creation, lastmod, visite). default rilevanza
 ** opt: ordtype tipo di ordinamento (puo' essere ASC -ascendente- o DESC -discendente-)
 ** opt: highlight il titolo corrente viene colorato del colore specificato
 ** opt: expand (true|false) se impostato a "true", per la sezione corrente fornisce {expand}, contenente la lista delle figlie
 ** opt: menu (dynamic) se impostato a "dynamic" permette di generare menu dinamici tramite liste e fogli di stile
 ** opt: clickonfirstnode se impostato a "disabled" rende il primo nodo non cliccabile
 ** opt: cols numero intero, determina in quante colonne mostrare i risultati. se specificato applica un div di contorno, con class="box_node" e id="box_idpagina", ad ogni blocco di loop
**  opt: extract intero, se specificato <nomecampo>_extract contiene i primi n caratteri trovati nel testo
 ** eg: <%branch relationship="figli" target="1" highlight="gold"%>
 ** eg: <a href="index.php?id={id}" accesskey="{accesskey}">{titolo}</a>
 ** eg: <%end%>
 **/
function branch (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{
    if (isset($options['parentela']) && !isset($options['relationship']))
        $options['relationship'] = $options['parentela'];

    switch ($options['relationship']) {
        case 'fratelli':case 'brothers':
            if (!$options['target'])
                $options['target'] = $content['id_parent'];
            $condition = " WHERE node.id_parent='".$options['target']."'";
        break;
        case 'genitore':case 'parent':
            if (!$options['target'])
                $options['target'] = $content['id_parent'];
            $condition = " WHERE node.id='".$options['target']."'";
        break;
        case 'sons':case 'figli':default:
            if (!$options['target'])
                $options['target'] = $content['id'];
            $condition = " WHERE node.id_parent='".$options['target']."'";
        break;
    }

    if ($options['ord'])
        $order = $options['ord'];
    else
        $order = "rilevanza";
    if ($options['ordtype'])
        $order_type = $options['ordtype'];
    else
        $order_type = "DESC";

    $paperwhere = '';
    if ($options['show'] == 'news') {
        $paperwhere = ' and (isanews=1 || isanews=2)';
        $condition .= $paperwhere;
    }
    elseif ($options['show'] == 'node') {
        $paperwhere = ' and (isanews=0 || isanews=2)';
        $condition .= $paperwhere;
    }

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    $dbquery = "SELECT * FROM node $condition $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] and ((`segnalibro` IS NULL) or (`segnalibro` = '')) and ((`navigatore` is NULL) or (`navigatore` = '')) ORDER BY $order $order_type";
    $rowrs = select($dbquery, $connh);

    $i = 1;
    if ($rowrs->RecordCount() > 0)
    while (!$rowrs->EOF) {
        $row = $rowrs->fields;

        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
        $row['contenuto'] = $row['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $content_query = "SELECT * FROM ".$row['contenuto']." WHERE id='".$row['id']."' LIMIT 0,1";
        $content_rs = select($content_query, $connh);
        if ($content_rs->RecordCount()) {
            $content_row = $content_rs->fields;
            $row = array_merge($row, $content_row);
        }

        if ($options["extract"] > 0) {
            foreach ($row as $field => $value) {
                $index = $field.'_extract';

                if ($value{$options['extract']} == ' ')
                    $row[$index] = substr($value, 0, $options['extract']);
                else {
                    $char = '';
                    $pos = $options['extract'] + 1;
                    while ($char != ' ' && $pos <= strlen($value)) {
                        $char = $value{$pos};
                        $pos++;
                    }
                    $row[$index] = substr($value, 0, $pos);
                }
            }
        }

        if ($have_seo)
            $row["page"] = maketitle($row["id"],  seotitle($row["titolo"]));

        $row['corrente'] = '';
        if ($_GET['id'] == $row['id'])
            $row['corrente'] = 'corrente';

        // param highlight
        if ($options['highlight'] != '') {
            if ($row['id'] == $content['id'])
                $row['titolo'] = "<span style=\"color:".$options['highlight']."\">".$row['titolo']."</span>";
        }
        // param expand
        if ($options['expand'] == 'true') {
            if ($content['id'] == $row['id'] ||
               ($content['id_parent'] == $PRISCILLA_SESSION->getvalue('expandedNode') &&
                $row['id'] == $content['id_parent']) || $row['id'] == $_GET['from']) {

                $row['corrente'] = 'uppercorrente';

                $query = "SELECT * FROM node WHERE id_parent='".$row['id']."' $paperwhere $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] ORDER BY $order $order_type";
                $rs = select($query, $connh);
                if ($rs->RecordCount() > 0) {
                    $row['expand'] .= "<ul>";
                    while (!$rs->EOF) {
                         if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
                            $rs->fields['contenuto'] = $rs->fields['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');
                        $content_query = "SELECT * FROM ".$rs->fields['contenuto']." WHERE id='".$rs->fields['id']."' LIMIT 0,1";
                        $content_rs = select($content_query, $connh);

                        $classc = '';
                        if ($_GET['id'] == $rs->fields['id'])
                            $classc = " class=\"$classc\"";

                        if ($have_seo)
                            $page_idx = "\" href=\"" . maketitle($rs->fields('id'),  seotitle($row["titolo"]));

                        else
                            $page_idx = "\" href=\"index.php?id=" . $rs->fields['id'];


                        $row['expand'] .= "<li$classc><a title=\"".$content_rs->fields['titolo'] . $page_idx . "\" class=\"expand\"";

                        $row ['expand'] .= ">";
                        $row['expand'] .= $content_rs->fields['titolo'];
                        $row['expand'] .= "</a></li>\n";

                        $rs->MoveNext();
                    }
                    $row['expand'] .= "</ul>";

                    $PRISCILLA_SESSION->add('expandedNode', $row[id]);
                }
            }
        }

        if ($options['menu'] == 'dynamic') {

            // i figli di questo figlio....
            $dbquery = "SELECT * FROM node LEFT JOIN `".$row['contenuto']."` ON (node.id=`".$row['contenuto']."`.id) WHERE id_parent='$row[id]' $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] and ((`segnalibro` IS NULL) or (`segnalibro` = '')) and ((`navigatore` is NULL) or (`navigatore` = '')) ORDER BY $order $order_type";
            $rs1 = $connh->Execute($dbquery) or die($dbquery."<br />".$connh->ErrorMsg());
 
            if ($rs1->RecordCount() != 0) {
                $row['subfigli'] = "";
                $row['subsons'] = "";
                while (!$rs1->EOF) {

                    if ($options["hisub"] != "") {
                        if ($rs1->fields('id') == $_GET['id'])
                            $s_class = "class=\"" . $options["hisub"] . "\"";
                        else
                            $s_class = "";
                        }
                    else $s_class = "";

                    if ($have_seo)
                        $row['subfigli'] .=
                        "<li><a $s_class href=\"" . maketitle($rs1->fields('id'), seotitle($rs1->fields('titolo')))   . "\">" .
                        $rs1->fields['titolo'] .
                        "</a></li>\n";
                    else
                        $row['subfigli'] .=
                        "<li><a $s_class href=\"index.php?id=" . $rs1->fields('id')  . "\">" .
                        $rs1->fields['titolo'] .
                        "</a></li>\n";


                    $rs1->MoveNext();
                } // while
                $row['subsons'] = $row['subfigli'];
            } // ($rs1->RecordCount
        }  // if (trim

        if ($options['cols']) {
            if ($i < $options['cols'])
                $publisher->publish("<div style=\"float:left\" id=\"box_".$row['id']."\" class=\"box_node\">".$blocco."</div>", $risoluzione, $row);
            else {
                $publisher->publish("<div style=\"float:left\" id=\"box_".$row['id']."\" class=\"box_node\">".$blocco."</div><div style=\"clear:left\"></div>", $risoluzione, $row);
                $i = 0;
            }
        }
        else
            $publisher->publish($blocco, $risoluzione, $row);

        $i++;
        $rowrs->MoveNext();
    }
}

/** 
 ** tag: menu
 ** desc: loop di tutte le pagine associate al menu specificato
 ** opt: name il nome di menu da cui estrarre
 ** opt: show puo` essere news o node. se non fornito vengono visualizzati entrambi.
 ** opt: ord puo' essere title. Di default vengono usate le impostazioni salvate per il menu
 ** eg: <%menu name="mymenu"%>
 ** eg: <a href="index.php?id={id}">{titolo}</a>
 ** eg: <%end%>
 **/
function menu (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{

    if (!$options['name'])
        return 0;

    $rsmenu = select("SELECT * FROM menu WHERE name='".$options['name']."'", $connh);
    if (!$rsmenu->RecordCount())
        return 0;


    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    if ($options["ord"] == "title")
        $rs = select("SELECT * FROM menunode LEFT JOIN node ON (node.id=menunode.id_node) WHERE id_menu='".$rsmenu->fields['id'] . "' $GLOBALS[extra] ORDER BY node.sezione ASC", $connh);
    else
        $rs = select("SELECT * FROM menunode LEFT JOIN node ON (node.id=menunode.id_node) WHERE id_menu='".$rsmenu->fields['id'] . "' $GLOBALS[extra] ORDER BY node.rilevanza ASC", $connh);

    if ($rs->RecordCount())
    while (!$rs->EOF) {
        $row = $rs->fields;

        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
        $row['contenuto'] = $row['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $content_query = "SELECT * FROM ".$row['contenuto']." WHERE id='".$row['id_node']."' LIMIT 0,1";
        $content_rs = select($content_query, $connh);
        if ($content_rs->RecordCount()) {
            $content_row = $content_rs->fields;
            $row = array_merge($row, $content_row);
        }

        if ($have_seo)
            $row["page"] = maketitle($row["id"],  seotitle($row["titolo"]));

        $row['corrente'] = '';
        if ($_GET['id'] == $row['id'])
            $row['corrente'] = 'corrente';

        $publisher->publish($blocco, $risoluzione, $row);
        $rs->MoveNext();
    }
}

/** 
 ** tag: news
 ** desc: estrae le ultime n pagine in ordine di creazione o ultima modifica
 ** opt: target il ramo da cui estrarre le informazioni, se non fornito default pagina corrente
 ** opt: show puo` essere news o node. se non fornito vengono visualizzati entrambi.
 ** opt: n numero di nodi da estrarre
 ** opt: ord campo di ordinamento, puo` essere creation o lastmod. default lastmod
 ** eg: <%news n="8" show="news" ord="creation"%>
 ** eg: <a href="index.php?id={id}">{titolo}</a>
 ** eg: <%end%>
 **/
function news (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    if (!function_exists('getAllRowRec')) {
        function getAllRowRec($id, $connh, $param, &$allRow)
        {
            $paperwhere = '';
            if ($options['show'] == 'news')
                $paperwhere = ' and (isanews=1 || isanews=2)';
            elseif ($options['show'] == 'node')
                $paperwhere = ' and (isanews=0 || isanews=2)';

            $query = "SELECT * FROM node WHERE id_parent='".$id."' $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] ".$paperwhere;
            $rs = select($query, $connh);
            while (!$rs->EOF) {
                $row = $rs->fields;

                if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != SWAPLANG_DEFAULT_LANG)
                    $row['contenuto'] = $row['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

                $content_query = "SELECT * FROM ".$row['contenuto']." WHERE id='".$row['id']."'  LIMIT 0,1";
                $content_rs = select($content_query, $connh);
                if ($content_rs->RecordCount()) {
                    $content_row = $content_rs->fields;
                    foreach ($content_row as $field => $value) {
                        $index = $field.'_extract';

                        if ($options['extract'] > 0) {
                            if ($value{$options['extract']} == ' ')
                                $row[$index] = substr($value, 0, $options['extract']);
                            else {
                                $char = '';
                                $pos = $options['extract'] + 1;
                                while ($char != ' ' && $pos <= strlen($value)) {
                                    $char = $value{$pos};
                                    $pos++;
                                }
                                $row[$index] = substr($value, 0, $pos);
                            }
                        }
                        else
                            if (is_string($value) && strstr($value, '</p>')) {
                                preg_match('/<p\s*[\w\W]*>([\w\W]*)<\/p>/Umi', $value, $matches);
                                $row[$index] = $matches[1];
                            }
                    }
                    $row = array_merge($row, $content_row);
                }

                $index = date("Ymdhi", strtotime($row[$param['ord']]));
                $allRow[$index] = $row;

                getAllRowRec($row['id'], $connh, $param, $allRow);
                $rs->MoveNext();
            }
        }
    }

    if (!$options['ord'] || $options['ord'] != ('lastmod' || 'creation'))
        $options['ord'] = 'lastmod';

    if (!$options['n'])
        $options['n'] = 5;

    if (!$options['target'])
        $options['target'] = $_GET['id'];

    $allRow = array();
    getAllRowRec($options['target'], $connh, $options, $allRow);
    krsort($allRow, SORT_NUMERIC);

    $c = 0;
    foreach ($allRow as $key => $val) {

        if ($have_seo)
            $val["page"] = maketitle($val["id"],  seotitle($val["titolo"]));

        if ($c < $options['n'])
            $publisher->publish($blocco, $risoluzione, $val);
        else break;
        $c++;
    }
}

/**
 ** tag: taglist
 ** target id della pagina (se non indicato lista i tag della pagina corrente)
 ** desc: mostra i tag della pagina corrente
 ** eg: id in href e' l'id della pagina che contiene il tag tagrelated
 ** eg:
 ** eg: <%taglist%>
 ** eg: <span class="small"><a href="index.php?id=28&tag={tag}&cnt=base">#{tag}</a></span>
 ** eg: <%end%>
 **/
function taglist (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{
    if (!$options['target']) {
        if (isset($_GET['id']))
            $options['target'] = $_GET['id'];
    }


    if (!is_numeric($options['target']))
        return;

    $dbquery = "SELECT `contenuto` FROM node WHERE id = " . $options['target'] . " LIMIT 1";
    $rs = select($dbquery, $connh);
    $contenuto = $rs->fields('contenuto');

    $dbquery = "SELECT `tags` FROM `$contenuto` WHERE `id` = " . $options['target'] . " LIMIT 1";
    $rs = select($dbquery, $connh);
    $tags = $rs->fields('tags');


    $a_tags = explode(",", $tags);
    $a_seen[] = array();

    foreach ($a_tags as $ct) {
        $t = trim(strtolower($ct));
        if (!in_array($t, $a_seen)) {
            $val['tag'] = $t;
            $publisher->publish($blocco, $risoluzione, $val);
            $a_seen[] = $t;
        }
    }
}

/**
 ** tag: tagrelated
 ** desc: mostra elenco pagine hanno il tag fornito via get
 ** desc: la pagina che contiene questo tag loop deve avere ?tag=nometag&cnt=content passato via get
 ** eg:
 ** eg: <p>Archivio pagine relative a: <strong>#{getArgs from="get" key="tag"}</strong></p>
 ** eg: <ul class="lista-pagtag">
 ** eg: <%tagrelated%>
 ** eg: <li><a href="{page}">{titolo}</a></li>
 ** eg: <%end%>
 ** eg: </ul>
 **
 **/
function tagrelated (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

 
    if (trim($_GET['tag']) == '' || trim($_GET['cnt']) == '')
        return;

    $tag = $_GET['tag'];

    $content_table = "content_" . $_GET['cnt'];

    $dbquery = "SELECT * FROM `node` LEFT JOIN `" . $content_table . "` ON (`node`.`id` = `" . $content_table . "`.`id`)  WHERE (`tags` LIKE '$tag,%' OR `tags` LIKE '%,$tag,%' OR `tags` LIKE '%,$tag') AND `node`.`pubblicazione` = 'pubblica'";

    $rs = select($dbquery, $connh);
    
    if ($rs && $rs->RecordCount()) {
        while (!$rs->EOF) {
            $row = $rs->fields;

            if ($have_seo)
                $row["page"] = maketitle($row["id"],  seotitle($row["titolo"]));

            $publisher->publish($blocco, $risoluzione, $row);
            $rs->MoveNext();
        }
    }    
}

?>
